<?php if (!defined('PmWiki')) exit();
/*
  Copyright 2004 Bronwyn Boltwood (arndis@gmail.com)
  This file does the heavy lifting for saving configurations of the Lens
  skin.  It was created after examining PmWiki's scripts/skins.php.
*/

global $LoFi, $HiFi, $Skin, $SkinDir, $SkinDirUrl, $FarmD, $HTMLStylesFmt;

## define paths and names for the css files generated
$LoFiFile = 'lofi.css';
$HiFiFile = 'hifi.css';
$LoFiPath = "$SkinDir/$LoFiFile";
$HiFiPath = "$SkinDir/$HiFiFile";
$LoFiUrl = "$SkinDirUrl/$LoFiFile";
$HiFiUrl = "$SkinDirUrl/$HiFiFile";

## write css files for $LoFi and $HiFi arrays
write_css_file($LoFi, $LoFiPath, "@import url(", ");");  #even older browsers understand this @import rule
write_css_file($HiFi, $HiFiPath, "@import'", "';");  #only modern browsers understand this @import rule

## add css files to PmWiki's page headers
$ImportLoFi = "\n@import url($LoFiUrl);";
$ImportHiFi = "\n@import'$HiFiUrl';\n";
array_unshift($HTMLStylesFmt, $ImportLoFi, $ImportHiFi);

/*
echo "<h3>Contents of array \$HTMLStylesFmt</h3>";
echo "<table border='1'><tr><th>key</th><th>value</th></tr>";
foreach ($HTMLStylesFmt as $key => $value) {
echo "<tr><td>$key</td><td><pre>$value</pre></td></tr>";
}
echo "</table>";
echo "<p>\$PukkaPath is $PukkaPath</p>";
echo "<p>\$PukkaUrl is $PukkaUrl</p>";
*/

## load the centrally stored template
LoadPageTemplate($pagename, "$LensSharedPath/lens.tmpl");

/* ---- Define the write_css_file function ---- */
function write_css_file($list, $file, $importbegin, $importend)
{
## check if $file exists
	if (file_exists($file))
	## if so, put it into array $OldConfig for later use, and tell me the file exists
	{
		$OldConfig = file_get_contents($file);
		#echo "<p>Existing config $file found</p>";
	}
	else
	## otherwise, create new file named $file
	{
		## grab the file handle created by fopen for later use
		## exit if something goes wrong
		$filehandle = fopen($file, 'w') or exit("<p>Cannot create $file</p>");
		## close the file so we can't have any accidents with it
		fclose($filehandle);
	}
	## create empty array to store the results
	$NewConfigArray = array();
	global $LensSharedPath, $LensSharedUrl;
	## iterate through the array $list
	foreach ($list as $opt)
	{
		## add an item to array $NewConfig, which, if parameters have been specified correctly, will be a valid @import rule
		$NewConfigArray[] = $importbegin.$LensSharedUrl.'/css/'.$opt.'.css'.$importend;
	}
	## glue contents of $NewConfig into a string for easy comparison with $OldConfig, then compare them
	$NewConfig = implode("\n", $NewConfigArray);
	if ($NewConfig == $OldConfig)
	{
		## tell me the configurations are identical, get out of the if, and go on with the script
		#echo "<p>Identical configurations; no changes made to $file.css</p>";
	}
	else
	{
		## write new configuration to $file and tell me you did so -- pity I can't use file_put_contents(), but my host and others don't have PHP5 yet
		## grab the file handle created by fopen for later use
		## exit if something goes wrong
		$filehandle = fopen($file, 'w') or exit("Cannot write to $file");
		## actually write the data to the file
		fwrite($filehandle, $NewConfig);
		## close the file so we can't have any accidents with it
		fclose($filehandle);
		#echo "<p>New configuration saved to $file.css</p>";
	}
}
?>
